import { Plugin, NodeInterface, SchemaInterface } from '@aomao/engine';
import type MarkdownIt from 'markdown-it';
import HrComponent, { HrValue } from './component';
import { HrOptions } from './types';
export default class<T extends HrOptions = HrOptions> extends Plugin<T> {
    static get pluginName(): string;
    init(): void;
    execute(): void;
    hotkey(): string | string[];
    markdownIt: (mardown: MarkdownIt) => void;
    pasteSchema: (schema: SchemaInterface) => void;
    pasteHtml: (node: NodeInterface) => boolean | undefined;
    parseHtml: (root: NodeInterface, callback?: ((node: NodeInterface, value: HrValue) => NodeInterface) | undefined) => NodeInterface[];
    destroy(): void;
}
export { HrComponent };
export type { HrValue };
