import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { CardType, SelectStyleType, Card, isEngine, CARD_KEY, $, decodeCardValue, CARD_VALUE_KEY, Plugin } from '@aomao/engine';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".am-engine .card-hr,.am-engine-view .card-hr {\r\n    border: 1px solid transparent;\r\n    padding: 18px 0;\r\n    border-radius: 2px 2px;\r\n}\r\n\r\n.am-engine .card-hr hr,.am-engine-view .card-hr hr {\r\n    box-sizing: border-box;\r\n    position: absolute;\r\n    top: 50%;\r\n    left: 0;\r\n    margin-top: -1px;\r\n    width: 100%;\r\n    height: 2px;\r\n    background-color: #e8e8e8;\r\n    padding: 0;\r\n    border: 1px solid transparent;\r\n}\r\n\r\n.am-engine .card-hr:hover , .am-engine .card-hr.hr-activated {\r\n    background-color: #f4f4f4;\r\n}";
styleInject(css_248z);

var Hr = /*#__PURE__*/function (_Card) {
  _inherits(Hr, _Card);

  var _super = _createSuper(Hr);

  function Hr() {
    _classCallCheck(this, Hr);

    return _super.apply(this, arguments);
  }

  _createClass(Hr, [{
    key: "toolbar",
    value: function toolbar() {
      var _editor$plugin$findPl;

      var editor = this.editor;

      var getItems = function getItems() {
        if (!isEngine(editor) || editor.readonly) return [];
        return [{
          key: 'dnd',
          type: 'dnd'
        }, {
          key: 'copy',
          type: 'copy'
        }, {
          key: 'delete',
          type: 'delete'
        }];
      };

      var options = (_editor$plugin$findPl = editor.plugin.findPlugin('hr')) === null || _editor$plugin$findPl === void 0 ? void 0 : _editor$plugin$findPl.options;

      if (options === null || options === void 0 ? void 0 : options.cardToolbars) {
        return options.cardToolbars(getItems());
      }

      return getItems();
    }
  }, {
    key: "onActivate",
    value: function onActivate(activated) {
      _get(_getPrototypeOf(Hr.prototype), "onActivate", this).call(this, activated);

      var activatedClass = 'hr-activated';
      var center = this.getCenter();

      if (activated) {
        center.addClass(activatedClass);
      } else center.removeClass(activatedClass);
    }
  }, {
    key: "onSelectByOther",
    value: function onSelectByOther(selected, value) {
      _get(_getPrototypeOf(Hr.prototype), "onSelectByOther", this).call(this, selected, value);

      this.getCenter().find('hr').css('background-color', selected ? value.rgb : '');
    }
  }, {
    key: "onActivateByOther",
    value: function onActivateByOther(activated, value) {
      this.onSelectByOther(activated, value);
    }
  }, {
    key: "render",
    value: function render() {
      this.getCenter().addClass('card-hr');
      return '<hr />';
    }
  }], [{
    key: "cardName",
    get: function get() {
      return 'hr';
    }
  }, {
    key: "cardType",
    get: function get() {
      return CardType.BLOCK;
    }
  }, {
    key: "autoActivate",
    get: function get() {
      return false;
    }
  }, {
    key: "selectStyleType",
    get: function get() {
      return SelectStyleType.BACKGROUND;
    }
  }]);

  return Hr;
}(Card);

var PARSE_HTML = 'parse:html';
var PASTE_SCHEMA = 'paste:schema';
var PASTE_EACH = 'paste:each';
var MARKDOWN_IT = 'markdown-it';

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.markdownIt = function (mardown) {
      if (_this.options.markdown !== false) {
        mardown.enable('hr');
      }
    };

    _this.pasteSchema = function (schema) {
      schema.add([{
        type: 'block',
        name: 'hr',
        isVoid: true
      }]);
    };

    _this.pasteHtml = function (node) {
      var editor = _this.editor;
      if (!isEngine(editor)) return;

      if (node.name === 'hr') {
        editor.card.replaceNode(node, Hr.cardName);
        return false;
      }

      return true;
    };

    _this.parseHtml = function (root, callback) {
      var results = [];
      root.find("[".concat(CARD_KEY, "=").concat(Hr.cardName, "]")).each(function (hrNode) {
        var node = $(hrNode);
        var hr = node.find('hr');
        hr.css({
          'background-color': '#e8e8e8',
          border: '1px solid transparent',
          margin: '18px 0'
        });

        if (callback) {
          var card = _this.editor.card.find(node);

          var value = (card === null || card === void 0 ? void 0 : card.getValue()) || decodeCardValue(node.attributes(CARD_VALUE_KEY));
          hr = callback(hr, value);
        }

        node.replaceWith(hr);
        results.push(hr);
      });
      return results;
    };

    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var editor = this.editor;
      editor.on(PARSE_HTML, this.parseHtml);
      editor.on(PASTE_SCHEMA, this.pasteSchema);
      editor.on(PASTE_EACH, this.pasteHtml);

      if (isEngine(editor)) {
        editor.on(MARKDOWN_IT, this.markdownIt);
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      var editor = this.editor;
      if (!isEngine(editor)) return;
      var card = editor.card;
      card.insert(Hr.cardName);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || 'mod+shift+e';
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var editor = this.editor;
      editor.off(PARSE_HTML, this.parseHtml);
      editor.off(PASTE_SCHEMA, this.pasteSchema);
      editor.off(PASTE_EACH, this.pasteHtml);

      if (isEngine(editor)) {
        editor.off(MARKDOWN_IT, this.markdownIt);
      }
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'hr';
    }
  }]);

  return _default;
}(Plugin);

export default _default;
export { Hr as HrComponent };
